   MEMBER

   MAP
 MODULE('win32.lib')
    APICreateFile( *CSTRING lpszName, ulong fdwAccess, ulong fdwShareMode, ulong SecurityDescriptor, ulong fewCreate, ulong fewAttrsAndFlags, ulong hTemplateFile), name( 'CREATEFILEA'), long, short, raw, pascal
    GetCommState( ulong hCommDev, *group lpdcb), short, raw, pascal
    SetCommState( ulong hCommDev, *group lpdcb), short, raw, pascal
    ClearCommBreak( ulong hCommDev ), short, raw, pascal
    BuildCommDCB( *CSTRING lpazDef, *group lpdcb ), name('BUILDCOMMDCBA'), short, raw, pascal
    EscapeCommFunction( ulong hCommDev, ulong fdwFunc), short, raw, pascal
    PurgeComm( ulong hCommDev, ulong fdwAction ), short, raw, pascal
    SetCommTimeouts( ulong hCommDev, *group lpctmo), short, raw, pascal
    ReadFile( ulong hFile, *cstring buffer, ulong nNumberOfButesToRead, *ulong lpNumberofbytesread, ulong lpoverlapped), short, raw, pascal
    WriteFile( ulong hFile, *cstring buffer, ulong nNumberOfButesToWrite, *ulong lpNumberOfBytesWritten, ulong lpOverlapped), short, raw, pascal
    CloseHandle( ulong hObject ), short, raw, pascal
    SetupComm( ulong hCommDev, ulong cbInQueue, ulong cbOutQueue), ushort, raw, pascal
    GetLastError(),LONG,RAW,PASCAL
 END
      END
_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

  INCLUDE('Ports.INC'),ONCE
  
PortClass.Init PROCEDURE( STRING PortName )
Ret SHORT
   CODE
      SELF.NameCString = CLIP( PortName )
      SELF.Handle = APICreateFile( SELF.NameCString, 0C0000000h, 0, 0, 3, 0, 0 )
      IF SELF.Handle = -1
         SELF.LastError = GetLastError()
         RETURN 0
      ELSE
         SELF.LastError = 0
         Ret = GetCommState( SELF.Handle, SELF.DCB)
         IF Ret = 0 THEN SELF.LastError = GetLastError() END
         Ret = SELF.NormalTimeouts()
         RETURN Ret
         END
         
PortClass.SetUp PROCEDURE( )
Ret SHORT
uRet USHORT
   CODE
      SELF.DCB.Length = SIZE(SELF.DCB)
      Ret = SetCommState( SELF.Handle, SELF.DCB)
      IF Ret = 0
         SELF.LastError = GetLastError()
         END
      RETURN Ret

PortClass.Kill PROCEDURE()
Ret SHORT
   CODE
      Ret = CloseHandle(SELF.Handle)
      
PortClass.SetUpString PROCEDURE( STRING PortString ) !baud=9600 parity=N data=8 stop=1 and so on
cS CSTRING(255)
b SHORT
   CODE
     cS = CLIP(PortString)
     b = BuildCommDCB( cS, SELF.DCB )
     IF b <> 0 THEN b = SetCommState( SELF.Handle, SELF.DCB) END
     IF b = 0 THEN SELF.LastError = GetLastError() END
     RETURN b
     
PortClass.ClearIncoming PROCEDURE()
b SHORT
   CODE
      b = PurgeComm( SELF.Handle, 8 )
      IF b = 0
         SELF.LastError = GetLastError()
         END
      RETURN b

PortClass.ClearOutgoing PROCEDURE()
b SHORT
   CODE
      b = PurgeComm( SELF.Handle, 4 )
      IF b = 0
         SELF.LastError = GetLastError()
         END
      RETURN b

PortClass.Read PROCEDURE( *CSTRING buffer, ULONG bytes, *ULONG BytesRead )
b SHORT
   CODE
      b = ReadFile( SELF.Handle, buffer, bytes, BytesRead, 0 )
      IF b <> 0
         SELF.LastError = GetLastError()
         END
      RETURN b

PortClass.Write PROCEDURE( *CSTRING buffer, ULONG bytes )
b SHORT
Written ULONG
   CODE
      b = WriteFile( SELF.Handle, buffer, bytes, Written, 0 )
      IF b <> 0
         SELF.LastError = GetLastError()
         END
      RETURN b

PortClass.SetTimeouts PROCEDURE( ULONG ReadInterval, ULONG ReadMultiplier, ULONG ReadConstant, ULONG WriteMultiplier, ULONG WriteConstant )

St GROUP
A ULONG
B ULONG
C ULONG
D ULONG
E ULONG
   END

   CODE
      St.A = ReadInterval
      St.B = ReadMultiplier
      St.C = ReadConstant
      St.D = WriteMultiplier
      St.E = WriteConstant
      RETURN SetCommTimeouts( SELF.Handle, St )

PortClass.NormalTimeouts PROCEDURE()
   CODE
      RETURN SELF.SetTimeouts( 4294967295, 0, 0, 0, 0 )
