!ABCIncludeFile

OMIT('_EndOfInclude_',_PortClassPresent_)
_PortClassPresent_ EQUATE(1)

 
CBR_110  EQUATE(110)
CBR_300  EQUATE(300)
CBR_600  EQUATE(600)
CBR_1200 EQUATE(1200)
CBR_2400 EQUATE(2400)
CBR_4800 EQUATE(4800)
CBR_9600 EQUATE(9600)
CBR_14400 EQUATE(14400)
CBR_19200 EQUATE(19200)
CBR_38400 EQUATE(38400)
CBR_56000 EQUATE(56000)
CBR_57600 EQUATE(57600)
CBR_115200 EQUATE(115200)
CBR_128000 EQUATE(128000)
CBR_256000 EQUATE(256000)

CE_RXOVER           EQUATE(00001h)  ! Receive Queue overflow
CE_OVERRUN          EQUATE(00002h)  ! Receive Overrun Error
CE_RXPARITY         EQUATE(00004h)  ! Receive Parity Error
CE_FRAME            EQUATE(00008h)  ! Receive Framing error
CE_BREAK            EQUATE(00010h)  ! Break Detected
CE_TXFULL           EQUATE(00100h)  ! TX Queue is full
CE_PTO              EQUATE(00200h)  ! LPTx Timeout
CE_IOE              EQUATE(00400h)  ! LPTx I/O Error
CE_DNS              EQUATE(00800h)  ! LPTx Device not selected
CE_OOP              EQUATE(01000h)  ! LPTx Out-Of-Paper
CE_MODE             EQUATE(08000h)  ! Requested mode unsupported

IE_BADID            EQUATE(-1)      ! Invalid or unsupported id
IE_OPEN             EQUATE(-2)      ! Device Already Open
IE_NOPEN            EQUATE(-3)      ! Device Not Open
IE_MEMORY           EQUATE(-4)      ! Unable to allocate queues
IE_DEFAULT          EQUATE(-5)      ! Error in default parameters
IE_HARDWARE         EQUATE(-10)     ! Hardware Not Present
IE_BYTESIZE         EQUATE(-11)     ! Illegal Byte Size
IE_BAUDRATE         EQUATE(-12)     ! Unsupported BaudRate

EV_RXCHAR           EQUATE(00001h)  ! Any Character received
EV_RXFLAG           EQUATE(00002h)  ! Received certain character
EV_TXEMPTY          EQUATE(00004h)  ! Transmitt Queue Empty
EV_CTS              EQUATE(00008h)  ! CTS changed state
EV_DSR              EQUATE(00010h)  ! DSR changed state
EV_RLSD             EQUATE(00020h)  ! RLSD changed state
EV_BREAK            EQUATE(00040h)  ! BREAK received
EV_ERR              EQUATE(00080h)  ! Line status error occurred
EV_RING             EQUATE(00100h)  ! Ring signal detected
EV_PERR             EQUATE(00200h)  ! Printer error occured
EV_RX80FULL         EQUATE(00400h)  ! Receive buffer is 80 percent full
EV_EVENT1           EQUATE(00800h)  ! Provider specific event 1
EV_EVENT2           EQUATE(01000h)  ! Provider specific event 2

SETXOFF             EQUATE(1)       ! Simulate XOFF received
SETXON              EQUATE(2)       ! Simulate XON received
SETRTS              EQUATE(3)       ! Set RTS high
CLRRTS              EQUATE(4)       ! Set RTS low
SETDTR              EQUATE(5)       ! Set DTR high
CLRDTR              EQUATE(6)       ! Set DTR low
RESETDEV            EQUATE(7)       ! Reset device if possible
SETBREAK            EQUATE(8)       ! Set the device break line.
CLRBREAK            EQUATE(9)       ! Clear the device break line.

PURGE_TXABORT       EQUATE(00001h)  ! Kill the pending/current writes to the comm port.
PURGE_RXABORT       EQUATE(00002h)  ! Kill the pending/current reads to the comm port.
PURGE_TXCLEAR       EQUATE(00004h)  ! Kill the transmit queue if there.
PURGE_RXCLEAR       EQUATE(00008h)  ! Kill the typeahead buffer if there.
LPTx                EQUATE(080h)    ! Set if ID is for LPT device

MS_CTS_ON           EQUATE(00010h)
MS_DSR_ON           EQUATE(00020h)
MS_RING_ON          EQUATE(00040h)
MS_RLSD_ON          EQUATE(00080h)

PortClass CLASS,TYPE,MODULE('Ports.clw'),LINK('Ports.clw',_ABCLinkMode_),DLL(_ABCDLLMode_)
Handle SHORT
NameCString CSTRING(255)
LastError ULONG
DCB GROUP
Length ULONG
BaudRate ULONG
fBinary ULONG
fParity ULONG
fOutxCTSFlow ULONG
fOutxDSRFlow ULONG
fDTRControl ULONG
fDSRSensitivity ULONG
fTxContinueOnXOff ULONG
fOutX ULONG
fInX ULONG
fErrorChar ULONG
fNull ULONG
fRtsControl ULONG
fAbortOnError ULONG
Dummy2 ULONG
wReserved USHORT
XonLim USHORT
XoffLim USHORT
ByeSize BYTE
Parity BYTE
StopBits BYTE
XOnChar BYTE
XOffChar BYTE
ErrorChar BYTE
EvtChar BYTE
wReserved2 USHORT
   END

Init PROCEDURE( STRING PortName ),SHORT ! 0 if error
SetUp PROCEDURE( ),SHORT ! 0 if error
SetUpString PROCEDURE( STRING PortString ),SHORT !baud=9600 parity=N data=8 stop=1 and so on
Kill PROCEDURE( )
ClearIncoming PROCEDURE(),SHORT
ClearOutgoing PROCEDURE(),SHORT
Read PROCEDURE( *CSTRING buffer, ULONG bytes, *ULONG BytesRead ),SHORT
Write PROCEDURE( *CSTRING buffer, ULONG bytes ),SHORT
SetTimeouts PROCEDURE( ULONG ReadInterval, ULONG ReadMultiplier, ULONG ReadConstant, ULONG WriteMultiplier, ULONG WriteConstant ),SHORT
NormalTimeouts PROCEDURE(),SHORT
 END

_EndOfInclude_
